diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/wireless/wifi-simple-interference.cc ns-3.47/examples/wireless/wifi-simple-interference.cc
--- ns-3.46/examples/wireless/wifi-simple-interference.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/wireless/wifi-simple-interference.cc	2026-02-16 16:08:49.564229700 -0800
@@ -46,7 +46,7 @@
 // For instance, for this configuration, the interfering frame arrives
 // at -90 dBm with a time offset of 3.2 microseconds:
 //
-// ./ns3 run "wifi-simple-interference --Irss=-90 --delta=3.2ns"
+// ./ns3 run "wifi-simple-interference --Irss=-90 --delta=3.2us"
 //
 // Note that all ns-3 attributes (not just the ones exposed in the below
 // script) can be changed at command line; see the documentation.
@@ -60,18 +60,22 @@
 // If you have tcpdump installed, you can try this:
 //
 // tcpdump -r wifi-simple-interference-0-0.pcap -nn -tt
-// reading from file wifi-simple-interference-0-0.pcap, link-type IEEE802_11_RADIO (802.11 plus BSD
-// radio information header) 10.008704 10008704us tsft 1.0 Mb/s 2437 MHz (0x00c0) -80dB signal -98dB
-// noise IP 10.1.1.2.49153 > 10.1.1.255.80: UDP, length 1000
+// reading from file wifi-simple-interference-0-0.pcap, link-type IEEE802_11_RADIO (802.11 plus
+// radiotap header) 10.008754 13308699848833236992us tsft fragmented 0.0 Mb/s 0 MHz 16dBm signal
+// 2dBm noise IP 10.0.0.2.49153 > 255.255.255.255.80: UDP, length 1000
+//
+// With a zero delta time offset, only the first packet will be decoded; the second packet
+// transmission must be delayed past the end of the first packet to receive it..
 //
 // Next, try this command and look at the tcpdump-- you should see two packets
 // that are no longer interfering:
-// ./ns3 run "wifi-simple-interference --delta=30000ns"
+// ./ns3 run "wifi-simple-interference --delta=9000us"
 
 #include "ns3/command-line.h"
 #include "ns3/config.h"
 #include "ns3/double.h"
 #include "ns3/internet-stack-helper.h"
+#include "ns3/ipv4-address-helper.h"
 #include "ns3/log.h"
 #include "ns3/mobility-helper.h"
 #include "ns3/mobility-model.h"
@@ -124,26 +128,11 @@
  *
  * @param socket The sending socket.
  * @param pktSize The packet size.
- * @param pktCount The packet counter.
- * @param pktInterval The interval between two packets.
  */
 static void
-GenerateTraffic(Ptr<Socket> socket, uint32_t pktSize, uint32_t pktCount, Time pktInterval)
+GenerateTraffic(Ptr<Socket> socket, uint32_t pktSize)
 {
-    if (pktCount > 0)
-    {
-        socket->Send(Create<Packet>(pktSize));
-        Simulator::Schedule(pktInterval,
-                            &GenerateTraffic,
-                            socket,
-                            pktSize,
-                            pktCount - 1,
-                            pktInterval);
-    }
-    else
-    {
-        socket->Close();
-    }
+    socket->Send(Create<Packet>(pktSize));
 }
 
 int
@@ -158,13 +147,9 @@
     bool verbose{false};
 
     // these are not command line arguments for this version
-    uint32_t numPackets{1};
-    Time interPacketInterval{"1s"};
     Time startTime{"10s"};
-    meter_u distanceToRx{100.0};
+    meter_u distanceToRx{100.0}; // If you change this, also change TxGain below
 
-    double offset{91}; // This is a magic number used to set the
-                       // transmit power, based on other configuration
     CommandLine cmd(__FILE__);
     cmd.AddValue("phyMode", "Wifi Phy mode", phyMode);
     cmd.AddValue("Prss", "Intended primary received signal strength (dBm)", Prss);
@@ -194,6 +179,9 @@
     // ns-3 supports RadioTap and Prism tracing extensions for 802.11b
     wifiPhy.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
 
+    // Disable preamble detection model to receive signals below -82 dBm
+    wifiPhy.DisablePreambleDetectionModel();
+
     YansWifiChannelHelper wifiChannel;
     wifiChannel.SetPropagationDelay("ns3::ConstantSpeedPropagationDelayModel");
     wifiChannel.AddPropagationLoss("ns3::LogDistancePropagationLossModel");
@@ -209,15 +197,23 @@
     // Set it to adhoc mode
     wifiMac.SetType("ns3::AdhocWifiMac");
     NetDeviceContainer devices = wifi.Install(wifiPhy, wifiMac, c.Get(0));
-    // This will disable these sending devices from detecting a signal
-    // so that they do not backoff
-    wifiPhy.Set("TxGain", DoubleValue(offset + Prss));
+    // Setting RxSensitivity to 0 dBm will disable the two sending devices from detecting
+    // received signals, so that they do not back off
+    wifiPhy.Set("RxSensitivity", DoubleValue(0));
+    // We use the TxGain parameter on each sender to control the received signal power.
+    // The transmit power is roughly 16 dBm.  The signal attenuation from both senders to
+    // the receiving device is 106.7 dB (100 meters at this frequency, based on the
+    // LogDistancePropagationLossModel).  We want the receive signal strength to be
+    // Prss dBm.  We therefore want to solve for the gain as follows:
+    // 16 dBm + TxGain - propagationLoss = Prss (dBm)
+    // Working backwards, TxGain = Prss (dBm) - 16 dB + 106.7 dB = Prss (dBm) + 90.7 dB
+    dB_u powerOffset{90.7};
+    wifiPhy.Set("TxGain", DoubleValue(Prss + powerOffset));
     devices.Add(wifi.Install(wifiPhy, wifiMac, c.Get(1)));
-    wifiPhy.Set("TxGain", DoubleValue(offset + Irss));
+    // Repeat for the interferer
+    wifiPhy.Set("TxGain", DoubleValue(Irss + powerOffset));
     devices.Add(wifi.Install(wifiPhy, wifiMac, c.Get(2)));
 
-    // Note that with FixedRssLossModel, the positions below are not
-    // used for received signal strength.
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
     positionAlloc->Add(Vector(0.0, 0.0, 0.0));
@@ -230,6 +226,11 @@
     InternetStackHelper internet;
     internet.Install(c);
 
+    Ipv4AddressHelper address;
+    address.SetBase("10.0.0.0", "255.255.255.0");
+    Ipv4InterfaceContainer ipInterfaces;
+    ipInterfaces = address.Assign(devices);
+
     TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
     Ptr<Socket> recvSink = Socket::CreateSocket(c.Get(0), tid);
     InetSocketAddress local = InetSocketAddress(Ipv4Address("10.1.1.1"), 80);
@@ -259,17 +260,13 @@
                                    startTime,
                                    &GenerateTraffic,
                                    source,
-                                   PpacketSize,
-                                   numPackets,
-                                   interPacketInterval);
+                                   PpacketSize);
 
     Simulator::ScheduleWithContext(interferer->GetNode()->GetId(),
                                    startTime + delta,
                                    &GenerateTraffic,
                                    interferer,
-                                   IpacketSize,
-                                   numPackets,
-                                   interPacketInterval);
+                                   IpacketSize);
 
     Simulator::Run();
     Simulator::Destroy();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/wireless/wifi-sleep.cc ns-3.47/examples/wireless/wifi-sleep.cc
--- ns-3.46/examples/wireless/wifi-sleep.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/wireless/wifi-sleep.cc	2026-02-16 16:08:49.564229700 -0800
@@ -107,7 +107,7 @@
     dBm_u txPowerStart{0.0};
     dBm_u txPowerEnd{15.0};
     uint32_t nTxPowerLevels{16};
-    uint32_t txPowerLevel{0};
+    uint32_t txPowerLevel{WIFI_MIN_TX_PWR_LEVEL};
     ampere_u idleCurrent{0.273};
     ampere_u txCurrent{0.380};
     bool verbose{false};
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/LICENSE ns-3.47/LICENSE
--- ns-3.46/LICENSE	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/LICENSE	2026-02-16 16:08:49.473229400 -0800
@@ -1,3 +1,8 @@
+This project contains contributions that are mostly licensed as GPLv2-only,
+but some code is licensed differently; the LICENSES directory contains
+the set of licenses present in the codebase.  The common denominator and
+requirement for contribution is compatibility with the GPLv2-only license.
+
 		    GNU GENERAL PUBLIC LICENSE
 		       Version 2, June 1991
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/ns3 ns-3.47/ns3
--- ns-3.46/ns3	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/ns3	2026-02-16 16:08:49.565229700 -0800
@@ -88,7 +88,7 @@
     # Instead of copying and pasting repeated arguments for each parser, we add them here
     for subparser in parsers:
         subparser_name = subparser.prog.replace("ns3", "").strip()
-        destination = ("%s_%s" % (subparser_name, dest)) if subparser_name else dest
+        destination = (f"{subparser_name}_{dest}") if subparser_name else dest
         subparser.add_argument(
             *arguments, help=help_msg, action=action, default=default_value, dest=destination
         )
@@ -96,13 +96,19 @@
 
 def parse_args(argv):
     py39args = {"exit_on_error": False}
+    py314args = {"color": False}
     if sys.version_info < (3, 9):
         py39args = {}
+    if sys.version_info < (3, 14):
+        py314args = {}
     parser = argparse.ArgumentParser(
-        description="ns-3 wrapper for the CMake build system", add_help=False, **py39args
+        description="ns-3 wrapper for the CMake build system",
+        add_help=False,
+        **py39args,
+        **py314args,
     )
 
-    sub_parser = parser.add_subparsers()
+    sub_parser = parser.add_subparsers(dest="subparser")
 
     parser.add_argument(
         "-h",
@@ -126,9 +132,7 @@
         metavar="compile_or_die",
     )
     parser_help = sub_parser.add_parser("help", help="Print a summary of available commands")
-    parser_help.add_argument(
-        "help", help="Print a summary of available commands", action="store_true", default=False
-    )
+
     # parser.add_argument('--docset',
     #               help=(
     #                   'Create Docset, without building. This requires the docsetutil tool from Xcode 9.2 or earlier.'
@@ -145,7 +149,7 @@
         formatter_class=argparse.RawTextHelpFormatter,
     )
     parser_build.add_argument(
-        "build",
+        "target",
         help=(
             "Build the entire project or the specified target and its dependencies.\n"
             "To get the list of targets, use:\n"
@@ -153,14 +157,11 @@
         ),
         action="store",
         nargs="*",
-        default=None,
-        metavar="target",
     )
 
     parser_configure = sub_parser.add_parser(
         "configure", help='Try "./ns3 configure --help" for more configuration options'
     )
-    parser_configure.add_argument("configure", action="store_true", default=False)
     parser_configure.add_argument(
         "-d",
         "--build-profile",
@@ -205,6 +206,7 @@
         ),
         ("build-version", "embedding git changes as a build version during build"),
         ("clang-tidy", "clang-tidy static analysis"),
+        ("clang-tidy-fix", "clang-tidy static analysis and apply automatic fixes"),
         ("dpdk", "the fd-net-device DPDK features"),
         ("eigen", "Eigen3 library support"),
         ("examples", "the ns-3 examples"),
@@ -321,18 +323,14 @@
     )
 
     parser_clean = sub_parser.add_parser("clean", help="Removes files created by ns3")
-    parser_clean.add_argument("clean", action="store_true", default=False)
 
     parser_distclean = sub_parser.add_parser(
         "distclean", help="Removes files created by ns3, tests and documentation"
     )
-    parser_distclean.add_argument("distclean", action="store_true", default=False)
 
     parser_install = sub_parser.add_parser("install", help="Install ns-3")
-    parser_install.add_argument("install", action="store_true", default=False)
 
     parser_uninstall = sub_parser.add_parser("uninstall", help="Uninstall ns-3")
-    parser_uninstall.add_argument("uninstall", action="store_true", default=False)
 
     parser_run = sub_parser.add_parser(
         "run",
@@ -340,7 +338,7 @@
         formatter_class=argparse.RawTextHelpFormatter,
     )
     parser_run.add_argument(
-        "run",
+        "target",
         help=(
             "Build and run the target executable.\n"
             "If --no-build is present, the build step is skipped.\n"
@@ -353,7 +351,6 @@
         ),
         default="",
         nargs="?",
-        metavar="target",
     )
     parser_run.add_argument(
         "--no-build", help="Skip build step.", action="store_true", default=False
@@ -426,20 +423,14 @@
     )
 
     parser_shell = sub_parser.add_parser(
-        "shell", help='Try "./ns3 shell --help" for more shell options'
-    )
-    parser_shell.add_argument(
-        "shell",
-        help="Export necessary environment variables and open a shell",
-        action="store_true",
-        default=False,
+        "shell", help="Export necessary environment variables and open a shell"
     )
 
     parser_docs = sub_parser.add_parser(
         "docs", help='Try "./ns3 docs --help" for more documentation options'
     )
     parser_docs.add_argument(
-        "docs",
+        "target",
         help="Build project documentation",
         choices=[
             "contributing",
@@ -545,8 +536,31 @@
         print("\n".join(textwrap.wrap(error_message, width=TERMINAL_WIDTH)))
         exit(1)
 
+    # Since Python 3.14, we cannot store_true positional arguments.
+    # To keep same behavior, we emulate what we had: one flag set to false for every subparser
+    # not set to anything. And build is an empty string.
+    def set_subparser_flags(parser, args):
+        sub_parser_actions = list(
+            filter(lambda x: isinstance(x, argparse._SubParsersAction), parser._actions)
+        )
+        sub_parsers = list(sub_parser_actions[0].choices.keys())
+        if args.subparser in sub_parsers:
+            sub_parsers.remove(args.subparser)
+
+        for parser in sub_parsers:
+            setattr(args, parser, "" if parser in ["build", "run", "show"] else False)
+
+        if args.subparser not in [None, "build", "run", "show"]:
+            setattr(args, args.subparser, True)
+
+        if args.subparser in ["build", "run", "docs"]:
+            setattr(args, args.subparser, args.target)
+        return args
+
+    args = set_subparser_flags(parser, args)
+
     # If run doesn't have a target, print the help message of the run parser
-    if "run" in args and args.run == "":
+    if args.subparser == "run" and args.run == "":
         parser_run.print_help()
         exit(-1)
 
@@ -792,23 +806,24 @@
                     current_cmake_generator = line.split("=")[-1]
 
     if not current_cmake_generator:
+        supported_cmake_generators = subprocess.check_output(["cmake", "--help"]).decode()
         # Search for available generators
-        cmake_generator_map = {
+        cmake_build_tool_to_generator_map = {
             "msbuild": "Visual Studio 17 2022",
             "ninja": "Ninja",
             "make": "Unix Makefiles",
             "xcodebuild": "Xcode",
         }
         available_generators = []
-        for generator in cmake_generator_map.keys():
-            if shutil.which(generator):
+        for build_tool, generator in cmake_build_tool_to_generator_map.items():
+            if shutil.which(build_tool) and generator in supported_cmake_generators:
                 available_generators.append(generator)
 
         # Select the first one
         if len(available_generators) == 0:
             raise Exception("No generator available.")
 
-        current_cmake_generator = cmake_generator_map[available_generators[0]]
+        current_cmake_generator = available_generators[0]
 
     return current_cmake_cache_folder, current_cmake_generator
 
@@ -1429,7 +1444,8 @@
 
 def run_step(args, target_to_run, target_args):
     libdir = "%s/lib" % out_dir
-
+    if not os.path.exists(libdir):
+        libdir += "64"
     custom_env = {
         "PATH": libdir,
         "PYTHONPATH": "%s/bindings/python" % out_dir,
@@ -1517,16 +1533,23 @@
 
         # running with command template?
         if args.command_template:
-            commands = (args.command_template % target_to_run).split()
-            check_program_installed(commands[0])
+            commands = args.command_template % f'"{target_to_run}"'
+            commands = list(re.findall(r'(?:".*?"|\S)+', commands))
+            commands = list(map(lambda x: x.replace('"', ""), commands))
             target_to_run = commands[0]
-            target_args = commands[1:] + target_args
+            commands = commands[1:]
+            check_program_installed(target_to_run)
+            target_args = commands + target_args
 
             # running mpi on the CI?
             if target_to_run in ["mpiexec", "mpirun"] and os.getenv("MPI_CI"):
                 if shutil.which("ompi_info"):
                     try:
-                        subprocess.check_call([target_to_run, "--allow-run-as-root", "dir"])
+                        subprocess.check_call(
+                            [target_to_run, "--allow-run-as-root", "cmake", "--version"],
+                            stdout=subprocess.DEVNULL,
+                            stderr=subprocess.DEVNULL,
+                        )
                         target_args = ["--allow-run-as-root"] + target_args
                     except subprocess.CalledProcessError:
                         pass
@@ -1970,6 +1993,19 @@
                 target_to_run = target_to_run[1:-1]
             target_to_run = target_to_run.split()
             target_to_run, target_args = target_to_run[0], target_to_run[1:]
+            # Remove version prefixes and build profile suffices if they exist
+            if os.path.basename(target_to_run).startswith("ns3"):
+                pardir = os.path.dirname(target_to_run)
+                components = os.path.basename(target_to_run).split("-")
+                if "ns3" in components[0]:
+                    components.pop(0)
+                if "dev" == components[0]:
+                    components.pop(0)
+                if "rc" in components[0]:
+                    components.pop(0)
+                if components[-1] in ["debug", "relwithdebinfo", "default", "optimized"]:
+                    components.pop(-1)
+                target_to_run = f"{pardir}/{'-'.join(components)}"
         else:
             raise Exception("You need to specify a program to run")
 
@@ -2052,6 +2088,24 @@
         elif ".py" in target_to_run and os.path.exists(target_to_run):
             # We let python scripts pass to be able to run ./utils/python-unit-tests.py
             pass
+        elif "clang-tidy" in target_to_run:
+            clang_tidy_versions = ["run-clang-tidy"]
+            clang_tidy_versions = list(map(lambda x: shutil.which(x), clang_tidy_versions))
+            clang_tidy_versions = list(filter(lambda x: x, clang_tidy_versions))
+            if not clang_tidy_versions:
+                raise Exception(
+                    "Clang-tidy not found; please install it, or modify the PATH environment variable"
+                )
+            target_to_run = clang_tidy_versions[-1]
+            target_args = [
+                "-p",
+                current_cmake_cache_folder,
+                "-quiet",
+                "-format",
+                "-warnings-as-errors=*",
+            ] + target_args
+            run_only = True
+            build_and_run = False
         else:
             raise Exception("Couldn't find the specified program: %s" % target_to_run)
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h ns-3.47/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h
--- ns-3.46/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h	2026-02-16 16:08:49.565229700 -0800
@@ -6,6 +6,9 @@
 // in a scratch subdirectory, one can create new programs that are implemented
 // in multiple files and headers.
 
+#ifndef SCRATCH_NESTED_SUBDIR_LIBRARY_HEADER_H
+#define SCRATCH_NESTED_SUBDIR_LIBRARY_HEADER_H
+
 #include <string>
 
 namespace ns3
@@ -19,3 +22,5 @@
 std::string ScratchNestedSubdirGetMessage();
 
 } // namespace ns3
+
+#endif // SCRATCH_NESTED_SUBDIR_LIBRARY_HEADER_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/scratch/subdir/scratch-subdir-additional-header.h ns-3.47/scratch/subdir/scratch-subdir-additional-header.h
--- ns-3.46/scratch/subdir/scratch-subdir-additional-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/scratch/subdir/scratch-subdir-additional-header.h	2026-02-16 16:08:49.565229700 -0800
@@ -6,6 +6,9 @@
 // in a scratch subdirectory, one can create new programs that are implemented
 // in multiple files and headers.
 
+#ifndef SCRATCH_SUBDIR_ADDITIONAL_HEADER_H
+#define SCRATCH_SUBDIR_ADDITIONAL_HEADER_H
+
 #include <string>
 
 namespace ns3
@@ -19,3 +22,5 @@
 std::string ScratchSubdirGetMessage();
 
 } // namespace ns3
+
+#endif // SCRATCH_SUBDIR_ADDITIONAL_HEADER_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/antenna/examples/adjacency-matrix-example.cc ns-3.47/src/antenna/examples/adjacency-matrix-example.cc
--- ns-3.46/src/antenna/examples/adjacency-matrix-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/antenna/examples/adjacency-matrix-example.cc	2026-02-16 16:08:49.566229800 -0800
@@ -7,6 +7,11 @@
  */
 
 /**
+ * @ingroup antenna
+ * @defgroup antenna-examples Antenna Examples
+ */
+
+/**
  * @file
  * @ingroup antenna-examples
  * Example program illustrating one application of symmetric adjacency matrices for routing
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/antenna/utils/symmetric-adjacency-matrix.h ns-3.47/src/antenna/utils/symmetric-adjacency-matrix.h
--- ns-3.46/src/antenna/utils/symmetric-adjacency-matrix.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/antenna/utils/symmetric-adjacency-matrix.h	2026-02-16 16:08:49.567229700 -0800
@@ -8,6 +8,7 @@
 #ifndef NS3_SYMMETRIC_ADJACENCY_MATRIX_H
 #define NS3_SYMMETRIC_ADJACENCY_MATRIX_H
 
+#include <algorithm>
 #include <vector>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/aodv/model/aodv-routing-protocol.cc ns-3.47/src/aodv/model/aodv-routing-protocol.cc
--- ns-3.46/src/aodv/model/aodv-routing-protocol.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/aodv/model/aodv-routing-protocol.cc	2026-02-16 16:08:49.568229700 -0800
@@ -1638,7 +1638,7 @@
     RrepHeader rrepHeader;
     p->RemoveHeader(rrepHeader);
     Ipv4Address dst = rrepHeader.GetDst();
-    NS_LOG_LOGIC("RREP destination " << dst << " RREP origin " << rrepHeader.GetOrigin());
+    NS_LOG_LOGIC("Route destination " << dst << " Route origin " << rrepHeader.GetOrigin());
 
     uint8_t hop = rrepHeader.GetHopCount() + 1;
     rrepHeader.SetHopCount(hop);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/aodv/test/aodv-regression.cc ns-3.47/src/aodv/test/aodv-regression.cc
--- ns-3.46/src/aodv/test/aodv-regression.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/aodv/test/aodv-regression.cc	2026-02-16 16:08:49.568229700 -0800
@@ -162,6 +162,9 @@
 {
     // 1. Setup WiFi
     int64_t streamsUsed = 0;
+    int64_t totalStreamsUsed = 0;
+    int64_t streamNumber = 0;
+    int64_t streamIncrement = 1000;
     WifiMacHelper wifiMac;
     wifiMac.SetType("ns3::AdhocWifiMac");
     YansWifiPhyHelper wifiPhy;
@@ -182,27 +185,47 @@
     NetDeviceContainer devices = wifi.Install(wifiPhy, wifiMac, *m_nodes);
 
     // Assign fixed stream numbers to wifi and channel random variables
-    streamsUsed += WifiHelper::AssignStreams(devices, streamsUsed);
-    // Assign 6 streams per device
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed, (devices.GetN() * 2), "Stream assignment mismatch");
-    streamsUsed += wifiChannel.AssignStreams(chan, streamsUsed);
+    constexpr int expectedWifiStreamsPerDevice = 2;
+    streamsUsed = WifiHelper::AssignStreams(devices, streamNumber);
+    totalStreamsUsed += streamsUsed;
+    streamNumber += streamIncrement;
+    // Assign 2 streams per device
+    NS_TEST_ASSERT_MSG_EQ(streamsUsed,
+                          (devices.GetN() * expectedWifiStreamsPerDevice),
+                          "Stream assignment mismatch");
+    streamsUsed = wifiChannel.AssignStreams(chan, streamNumber);
+    totalStreamsUsed += streamsUsed;
+    streamNumber += streamIncrement;
     // Assign 0 streams per channel for this configuration
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed, (devices.GetN() * 2), "Stream assignment mismatch");
+    NS_TEST_ASSERT_MSG_EQ(streamsUsed, 0, "No WifiChannel stream usage expected");
 
     // 2. Setup TCP/IP & AODV
     AodvHelper aodv; // Use default parameters here
     InternetStackHelper internetStack;
+    internetStack.SetIpv6StackInstall(false);
     internetStack.SetRoutingHelper(aodv);
     internetStack.Install(*m_nodes);
-    streamsUsed += internetStack.AssignStreams(*m_nodes, streamsUsed);
-    // InternetStack uses m_size more streams
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed, (devices.GetN() * 5) + m_size, "Stream assignment mismatch");
-    streamsUsed += aodv.AssignStreams(*m_nodes, streamsUsed);
-    // AODV uses m_size more streams
+    streamsUsed = internetStack.AssignStreams(*m_nodes, streamNumber);
+    totalStreamsUsed += streamsUsed;
+    streamNumber += streamIncrement;
+    constexpr int expectedArpL3ProtocolStreams = 1;
+    constexpr int expectedInternetStreamsPerDevice = expectedArpL3ProtocolStreams;
+    // InternetStack uses numDevices * expectedInternetStreamsPerDevice more streams
     NS_TEST_ASSERT_MSG_EQ(streamsUsed,
-                          ((devices.GetN() * 5) + (2 * m_size)),
+                          (devices.GetN() * expectedInternetStreamsPerDevice),
                           "Stream assignment mismatch");
 
+    constexpr int expectedAodvStreamsPerDevice = 1;
+    streamsUsed = aodv.AssignStreams(*m_nodes, streamNumber);
+    totalStreamsUsed += streamsUsed;
+    streamNumber += streamIncrement;
+    // AODV uses numDevices * expectedAodvStreamsPerDevice
+    NS_TEST_ASSERT_MSG_EQ(
+        totalStreamsUsed,
+        (devices.GetN() * (expectedWifiStreamsPerDevice + expectedInternetStreamsPerDevice +
+                           expectedAodvStreamsPerDevice)),
+        "Stream assignment mismatch");
+
     Ipv4AddressHelper address;
     address.SetBase("10.1.1.0", "255.255.255.0");
     Ipv4InterfaceContainer interfaces = address.Assign(devices);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/aodv/test/bug-772.cc ns-3.47/src/aodv/test/bug-772.cc
--- ns-3.46/src/aodv/test/bug-772.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/aodv/test/bug-772.cc	2026-02-16 16:08:49.569229800 -0800
@@ -124,6 +124,9 @@
 Bug772ChainTest::CreateDevices()
 {
     int64_t streamsUsed = 0;
+    int64_t totalStreamsUsed = 0;
+    int64_t streamNumber = 0;
+    int64_t streamIncrement = 1000;
     // 1. Setup WiFi
     WifiMacHelper wifiMac;
     wifiMac.SetType("ns3::AdhocWifiMac");
@@ -150,28 +153,51 @@
     NetDeviceContainer devices = wifi.Install(wifiPhy, wifiMac, *m_nodes);
 
     // Assign fixed stream numbers to wifi and channel random variables
-    streamsUsed += WifiHelper::AssignStreams(devices, streamsUsed);
+    streamsUsed = WifiHelper::AssignStreams(devices, streamNumber);
+    totalStreamsUsed += streamsUsed;
+    streamNumber += streamIncrement;
+    constexpr int expectedWifiStreamsPerDevice = 2;
     // Assign 6 streams per device
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed, (devices.GetN() * 2), "Stream assignment mismatch");
-    streamsUsed += wifiChannel.AssignStreams(chan, streamsUsed);
+    NS_TEST_ASSERT_MSG_EQ(streamsUsed,
+                          (devices.GetN() * expectedWifiStreamsPerDevice),
+                          "Stream assignment mismatch");
+    streamsUsed = wifiChannel.AssignStreams(chan, streamNumber);
+    totalStreamsUsed += streamsUsed;
+    streamNumber += streamIncrement;
     // Assign 0 streams per channel for this configuration
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed, (devices.GetN() * 2), "Stream assignment mismatch");
+    NS_TEST_ASSERT_MSG_EQ(streamsUsed, 0, "No WifiChannel stream usage expected");
 
     // 2. Setup TCP/IP & AODV
     AodvHelper aodv; // Use default parameters here
     InternetStackHelper internetStack;
+    internetStack.SetIpv6StackInstall(false);
     internetStack.SetRoutingHelper(aodv);
     internetStack.Install(*m_nodes);
-    streamsUsed += internetStack.AssignStreams(*m_nodes, streamsUsed);
-    // Expect to use (3*m_size) more streams for internet stack random variables
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed,
-                          ((devices.GetN() * 3) + (3 * m_size)),
-                          "Stream assignment mismatch");
-    streamsUsed += aodv.AssignStreams(*m_nodes, streamsUsed);
-    // Expect to use m_size more streams for AODV
-    NS_TEST_ASSERT_MSG_EQ(streamsUsed,
-                          ((devices.GetN() * 3) + (3 * m_size) + m_size),
-                          "Stream assignment mismatch");
+    streamsUsed = internetStack.AssignStreams(*m_nodes, streamNumber);
+    totalStreamsUsed += streamsUsed;
+    streamNumber += streamIncrement;
+
+    constexpr int expectedArpL3ProtocolStreams = 1;
+    constexpr int expectedInternetStreamsPerDevice = expectedArpL3ProtocolStreams;
+
+    // Expect number of streams assigned to match random variables streams used by wifi devices plus
+    // internet stack
+    NS_TEST_ASSERT_MSG_EQ(
+        totalStreamsUsed,
+        (devices.GetN() * (expectedWifiStreamsPerDevice + expectedInternetStreamsPerDevice)),
+        "Stream assignment mismatch");
+    streamsUsed = aodv.AssignStreams(*m_nodes, streamsUsed);
+    totalStreamsUsed += streamsUsed;
+    streamNumber += streamIncrement;
+
+    // Expect number of streams assigned to match random variables streams used by wifi devices plus
+    // internet and aodv stack
+    constexpr int expectedAodvStreamsPerDevice = 1;
+    NS_TEST_ASSERT_MSG_EQ(
+        totalStreamsUsed,
+        (devices.GetN() * (expectedWifiStreamsPerDevice + expectedInternetStreamsPerDevice +
+                           expectedAodvStreamsPerDevice)),
+        "Stream assignment mismatch");
     Ipv4AddressHelper address;
     address.SetBase("10.1.1.0", "255.255.255.0");
     Ipv4InterfaceContainer interfaces = address.Assign(devices);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/aodv/test/loopback.cc ns-3.47/src/aodv/test/loopback.cc
--- ns-3.46/src/aodv/test/loopback.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/aodv/test/loopback.cc	2026-02-16 16:08:49.569229800 -0800
@@ -139,6 +139,7 @@
     // Setup TCP/IP & AODV
     AodvHelper aodv; // Use default parameters here
     InternetStackHelper internetStack;
+    internetStack.SetIpv6StackInstall(false);
     internetStack.SetRoutingHelper(aodv);
     internetStack.Install(nodes);
     Ipv4AddressHelper address;
